//Подключение библиотеки управления моторами.
#include "motor.h"
//Номера пинов датчиков линии
const int left_line = 2;
const int right_line = 13;
//========================================
void fast_time_move(long ttime);
void setup()
{
  Serial.begin(9600);
  //1-черная, 0-белая
  pinMode(left_line, INPUT);
  pinMode(right_line, INPUT);

  // Переменные – номера контактов (пинов) Arduino.
  // Для левых и правых моторов машинки.
  setup_motor_system(3, 4, 11, 7, 8, 10);
  _stop(); //Двигатели остановлены.
  setspeed(255, 255);
  delay(1000);
  Serial.print(" Start ");
}
//=====================================
// Основная программа.
void loop()
{
  fast_time_move(10000);
  delay(10000);
}
//=====================================
void fast_time_move(long ttime)
{
  bool  left_li, right_li;
  long timerTec;
  long timerStart;
  timerTec =  micros();
  timerStart = timerTec + ttime * 1000;
  while ( (timerTec < timerStart) )
  {
    left_li = digitalRead(left_line);
    right_li = digitalRead(right_line);
    if ((!left_li) && (!right_li))
    {
      forward();
    }
    else
    {
      if (left_li && right_li)
      {
        right();
      }
      else
      {
        if (left_li)
        {
          left();
        }
        else
        {
          right();
        }
      }
    }
    delayMicroseconds(150);
    _stop();
    delayMicroseconds(100);
    timerTec =  micros();
  }
}

