#define TIME_TO_KEG 500000 // в микросекундах
#define TIME_TO_LINE 500000 // в микросекундах

//Подключение библиотеки I2C шины.
#include <Wire.h>
//Подключение библиотеки удаленного управления.
#include "IRremote.h"
//Побключение библиотеки управления моторами.
#include "motor.h"
//Подключение библиотеки управления гироскопом.
#include "gyro_acsel.h"
//Подключение библиотеки обработки цветов.
#include "memcolor.h"
void yellow_8(float aaa);
void red_8(float aaa);
// Порт для IR-приемника.
int RECV_PIN = A1;
// Создание IR-приемника.
IRrecv irrecv(RECV_PIN);
//Переменная для результатов IR-приемника.
decode_results results;
//========================================
void setup()
{
  Serial.begin(9600);
  //запуск гироскопа.
  giroscop_setup();
  apds9960_setup();
  // Переменные – номера контактов (пинов) Arduino.
  // Для левых и правых моторов машинки.
  setup_motor_system(3, 4, 11, 7, 8, 10);
  _stop(); //Двигатели остановлены.
  // Запуск IR-приемника.
  //Расчет компенсации утечки нуля гироскопа.
  delay(1000);
  Calc_CompensatorZ(3000);
  irrecv.enableIRIn();
  Serial.print(" Start ");
  Ang_ = 0;
  _stop(); //Двигатели остановлены.
  setspeed(255, 255);
}
//=====================================
// Основная программа.
void loop()
{
  // float Ang2 = Ang_;
  while (1)
  {
    // delay(30000);
    if (irrecv.decode(&results))
    {
      //  Serial.println(results.value, HEX);
      switch (results.value) {
        // 1 Желтые
        case 0xC101E57B:
          yellow_8(0);
          break;
        // 2 Красные
        case 0x97483BFB:
          red_8(0);
          break;
        // 3 фото желтые
        case 0xF0C41643:
          foto_yellow();
          break;
        // 4 желтые со смещением
        case 0x9716BE3F:
          yellow_8(22.5);
          break;
        // 5 Красные со смещением
        case 0x3D9AE3F7:
          red_8(22.5);
          break;
        // 6 фото красные
        case 0x6182021B:
          foto_red();
          break;
        // Вперед 10 сек
        case 0x511DBB:

          break;
        // Назад 10 сек
        case 0xA3C8EDDB:
          break;
        case 0x32C6FDF7: // "*"
          number_test_yellow = 0;
          number_test_red = 0;
          Serial.println("number_test_yellow = 0; number_test_red = 0;");
          break;
        case 0x1BC0157B: // "0"
          write_color_data_eeprom();
          break;
      }
      irrecv.resume();
    }
    // delay(40);
    time_gyro(0.5);
    apds9960_read();
  }
}
//=====================================
void yellow_8(float aaa)
{
  float x;
  x = aaa;
  while (x > 2)
  {
    Angle(x / 2);
    x = aaa - Ang_;
  }
  time_gyro(100);
  Ang_ = 0;
  for (int i = 0; i < 8; i++)
  {
    forward_t(TIME_TO_KEG);
    time_gyro(500);
    if (test_yellow())
    {
      //Serial.println(" Yellow ");
      forward_t(TIME_TO_LINE);
      time_gyro(500);
      backward_t(TIME_TO_LINE);
    }
    backward_t(TIME_TO_KEG);
    time_gyro(500);
    x = float((i + 1) * 45) - Ang_;
    while (x > 2)
    {
      Angle(x / 2);
      x = float((i + 1) * 45) - Ang_;
    }
    time_gyro(500);
  }
}
//=====================================
void red_8(float aaa)
{
  float x;
  x = aaa;
  while (x > 2)
  {
    Angle(x / 2);
    x = aaa - Ang_;
  }
  time_gyro(100);

  Ang_ = 0;
  for (int i = 0; i < 8; i++)
  {
    forward_t(TIME_TO_KEG);
    time_gyro(500);
    if (test_red())
    {
      // Serial.println(" red ");
      forward_t(TIME_TO_LINE);
      time_gyro(500);
      backward_t(TIME_TO_LINE);
    }
    backward_t(TIME_TO_KEG);
    time_gyro(500);
    x = float((i + 1) * 45) - Ang_;
    while (x > 2)
    {
      Angle(x / 2);
      x = float((i + 1) * 45) - Ang_;
    }
    time_gyro(500);
  }
}

